# Programmable SMS

## Summary

SMS (Short Message Service) is a messaging channel that allows businesses to communicate with customers through text messages on their mobile devices. With SMS, businesses can quickly and easily reach a large number of customers and automate their communication processes.

In addition in the United States and Canada it is also possible to send media messages through MMS (Multimedia Message Service).

## Installation

To send SMS messages you will need an SMS capable [number](https://app.gitbook.com/s/U9kiDiTGVD8kkbnKKyEn/channels/channels/supported-channels/numbers) and this will need to be [installed](https://docs.bird.com/api/channels-api/supported-channels/programmable-sms/installing-an-sms-channel) as an SMS channel. If the number is also MMS capable you will also be able to send media messages though the channel.

## Checking if a channel is MMS capable

You can validate if a channel is MMS capable by the capabilities object that is returned in the GET channel request

## Get channel

> Retrieve a specific workspace channel

```json
{"openapi":"3.0.3","info":{"title":"Channels","version":"v1"},"tags":[{"name":"channel","description":"Channels are the installation of a platform for a workspace."}],"servers":[{"url":"https://api.bird.com","description":"Production API"}],"security":[{"accessKey":[]}],"components":{"securitySchemes":{"accessKey":{"description":"Uses the Authorization header: 'AccessKey ' followed by your access key token (e.g., 'Authorization: AccessKey AbCdEfGhIjKlMnOpQrStUvWxYzAbCdEfGhIj')","scheme":"AccessKey","type":"http"}},"schemas":{"Channel":{"type":"object","title":"Channel","additionalProperties":false,"properties":{"id":{"$ref":"#/components/schemas/Id-2"},"platformId":{"$ref":"#/components/schemas/Id"},"name":{"$ref":"#/components/schemas/Name"},"connectorId":{"$ref":"#/components/schemas/ConnectorId"},"identifier":{"$ref":"#/components/schemas/Identifier"},"status":{"$ref":"#/components/schemas/Status-2"},"contactIdentifierKeyOverride":{"$ref":"#/components/schemas/ContactIdentifierKeyOverride"},"contactIdentifierFormatOverride":{"$ref":"#/components/schemas/ContactIdentifierFormatOverride"},"platformServiceUrlOverride":{"$ref":"#/components/schemas/PlatformServiceUrlOverride"},"platformServiceVersionOverride":{"$ref":"#/components/schemas/PlatformServiceVersionOverride"},"platformServiceProtocolOverride":{"$ref":"#/components/schemas/PlatformServiceProtocolOverride"},"platformMessageJsonSchemaOverride":{"$ref":"#/components/schemas/PlatformMessageJsonSchemaOverride"},"platformTemplateEngineOverride":{"$ref":"#/components/schemas/PlatformTemplateEngineOverride"},"capabilities":{"$ref":"#/components/schemas/ChannelCapabilities"},"settings":{"$ref":"#/components/schemas/Settings"},"connectionParams":{"$ref":"#/components/schemas/Settings"},"preferences":{"$ref":"#/components/schemas/Preferences"},"useCaseId":{"$ref":"#/components/schemas/UseCaseId"},"useCaseType":{"$ref":"#/components/schemas/UseCaseType-2"},"channelMessageType":{"$ref":"#/components/schemas/ChannelMessageType"},"suites":{"type":"array","items":{"$ref":"#/components/schemas/SuiteType"}},"resourceOwners":{"$ref":"#/components/schemas/ResourceOwners"},"createdAt":{"type":"string","format":"date-time"},"updatedAt":{"type":"string","format":"date-time"}},"required":["id","name","platformId","connectorId","status","createdAt"]},"Id-2":{"type":"string","format":"uuid"},"Id":{"type":"string","pattern":"^[A-Za-z0-9-]+$","minLength":3,"maxLength":60},"Name":{"type":"string","minLength":1,"maxLength":100},"ConnectorId":{"type":"string","format":"uuid"},"Identifier":{"type":"string","minLength":1,"maxLength":100},"Status-2":{"type":"string","enum":["active","pending","setting-up","failed","inactive","deleted","warning"]},"ContactIdentifierKeyOverride":{"type":"string","pattern":"^[A-Za-z0-9_-]+$","nullable":true},"ContactIdentifierFormatOverride":{"type":"object","additionalProperties":false,"properties":{"type":{"type":"string","enum":["none","pattern","phonenumber","emailaddress"]},"pattern":{"type":"string"}},"nullable":true},"PlatformServiceUrlOverride":{"type":"string","pattern":"^https://","nullable":true},"PlatformServiceVersionOverride":{"type":"string","enum":["1.0"],"nullable":true},"PlatformServiceProtocolOverride":{"type":"string","enum":["http","https"],"nullable":true},"PlatformMessageJsonSchemaOverride":{"type":"object","nullable":true},"PlatformTemplateEngineOverride":{"type":"string","nullable":true,"enum":["default","liquid"]},"ChannelCapabilities":{"type":"object","additionalProperties":false,"properties":{"messaging":{"type":"object","additionalProperties":true,"properties":{"messaging":{"$ref":"#/components/schemas/ChannelMessagingCapability"}}},"voice":{"type":"object","additionalProperties":true,"properties":{"voice":{"$ref":"#/components/schemas/ChannelVoiceCapability"}}}}},"ChannelMessagingCapability":{"type":"object","title":"Channel capability","additionalProperties":false,"properties":{"displayName":{"type":"string"},"status":{"type":"string"},"name":{"type":"string"},"version":{"type":"number"},"updatedAt":{"type":"string","format":"date-time"},"createdAt":{"type":"string","format":"date-time"},"expiresAt":{"type":"string","format":"date-time"},"outgoing":{"$ref":"#/components/schemas/ChannelOutgoingCapability"},"incoming":{"$ref":"#/components/schemas/ChannelIncomingCapability"}},"required":["status","name","version","updatedAt","createdAt","outgoing","incoming"]},"ChannelOutgoingCapability":{"type":"object","title":"Channel Outgoing capability","additionalProperties":false,"properties":{"displayName":{"type":"string"},"status":{"type":"string"},"name":{"type":"string"},"version":{"type":"number"},"updatedAt":{"type":"string","format":"date-time"},"createdAt":{"type":"string","format":"date-time"},"expiresAt":{"type":"string","format":"date-time"},"mms":{"$ref":"#/components/schemas/ChannelCapability"},"media":{"$ref":"#/components/schemas/ChannelOutgoingMediaMessageCapability"},"mmLite":{"$ref":"#/components/schemas/ChannelCapability"}},"required":["status","name"]},"ChannelCapability":{"type":"object","title":"Channel capability","additionalProperties":false,"properties":{"displayName":{"type":"string"},"status":{"type":"string"},"name":{"type":"string"},"version":{"type":"number"},"paused":{"type":"boolean","nullable":true},"updatedAt":{"type":"string","format":"date-time"},"createdAt":{"type":"string","format":"date-time"},"expiresAt":{"type":"string","format":"date-time"}},"required":["status","name","version","updatedAt","createdAt"]},"ChannelOutgoingMediaMessageCapability":{"type":"object","title":"Channel Outgoing Media Message Capability","additionalProperties":false,"properties":{"textFallback":{"$ref":"#/components/schemas/ChannelCapability"}}},"ChannelIncomingCapability":{"type":"object","title":"Channel Incoming capability","additionalProperties":false,"properties":{"displayName":{"type":"string"},"status":{"type":"string"},"name":{"type":"string"},"version":{"type":"number"},"updatedAt":{"type":"string","format":"date-time"},"createdAt":{"type":"string","format":"date-time"},"expiresAt":{"type":"string","format":"date-time"},"mms":{"$ref":"#/components/schemas/ChannelCapability"}},"required":["status","name"]},"ChannelVoiceCapability":{"type":"object","title":"Channel capability","additionalProperties":false,"properties":{"displayName":{"type":"string"},"status":{"type":"string"},"name":{"type":"string"},"version":{"type":"number"},"updatedAt":{"type":"string","format":"date-time"},"createdAt":{"type":"string","format":"date-time"},"expiresAt":{"type":"string","format":"date-time"},"recording":{"$ref":"#/components/schemas/ChannelCapability"}},"required":["status","name","version","updatedAt","createdAt","recording"]},"Settings":{"type":"array","items":{"type":"object","properties":{"key":{"type":"string"},"value":{"type":"string"},"displayName":{"type":"string"},"description":{"type":"string"},"visibility":{"type":"string","enum":["public","internal","secret"]}},"required":["key","value"]}},"Preferences":{"type":"object","nullable":true,"properties":{"disableProfileFetching":{"description":"When enabled, it skips fetching the sender profile details on incoming messages, and, therefore, contacts won't have profile details (first name, last name, display name, country, etc.). In case this preference is not provided during channel creation, the PII strategy defined in the workspace will be used.\n","type":"boolean"},"explicitMarketingOptOut":{"description":"When enabled, if a contact does not have a subscription attribute set for the corresponding platform, the contact will be treated as if it were subscribed when messaged through this channel. In case this preference is not provided during channel creation, the default value will be false.\n","type":"boolean"},"trackAdInitiatedThreads":{"description":"When enabled, it tracks the threads initiated by advertisements. In case this preference is not provided during channel creation, the default value will be false.\n"},"ignoreSuppressionChecks":{"description":"When enabled, it skips the suppression checks for the messages sent through this channel. In case this preference is not provided during channel creation, the default value will be false.\n","type":"boolean"},"isPrivate":{"description":"When enabled, it allows the channel to be marked as private - that is, the items which arrive via it,  should, in turn, be marked as private.\n","type":"boolean"},"disallowMmLite":{"description":"When enabled, Cloud API is used to send marketing messages.\n","type":"boolean"}}},"UseCaseId":{"type":"string","nullable":true},"UseCaseType-2":{"type":"string","nullable":true,"enum":["transactional","marketing","conversation"]},"ChannelMessageType":{"type":"string","enum":["promotional","2fa","conversational","transactional","emergency"]},"SuiteType":{"type":"string","description":"The Suite indicates a Suite that an entity belongs to","enum":["marketing","service","payments","automations","developer"]},"ResourceOwners":{"type":"object","nullable":true,"description":"The map of resource owners that are allowed to use this channel. Example:  { \"resourceOwnerIdentifier1\": { \"id\": \"resourceOwnerUUID1\", \"type\": \"user\" }, \n  \"resourceOwnerIdentifier2\": { \"id\": \"resourceOwnerUUID2\", \"type\": \"group\" } }\n","additionalProperties":{"type":"object","properties":{"id":{"type":"string","format":"uuid"},"type":{"type":"string","enum":["user","group"]}},"required":["id","type"]}},"RequestError":{"type":"object","properties":{"code":{"type":"string","description":"A unique code that identifies the error. This code can be used to programmatically identify the error.\n"},"message":{"type":"string","description":"A human-readable message that describes the error. An example is 'The requested resource does not exist: channel not found'.\n"}},"required":["code","message"]}},"responses":{"requestError":{"description":"The request did not pass validation","content":{"application/json":{"schema":{"$ref":"#/components/schemas/RequestError"}}}}}},"paths":{"/workspaces/{workspaceId}/channels/{channelId}":{"get":{"summary":"Get channel","operationId":"getChannel","description":"Retrieve a specific workspace channel","tags":["channel"],"responses":{"200":{"description":"OK","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Channel"}}}},"404":{"$ref":"#/components/responses/requestError"}}}}}}
```

If the channel is MMS capable, the following capabilities will show as active (otherwise inactive)

* `capabilities.messaging.outgoing.mms.status` = active
* `capabilities.messaging.inbound.mms.status` = active
